; mckwatch
;				build 2005/03/28
; ----------------------------------------------
; INCLUDE EXPAND COMMANDS
; ----------------------------------------------

	#include "hspext.as"
	#include "llmod.as"
	#include "obj.as"
	#include "dragdrop.as"

; ----------------------------------------------
; VERSION INFORMATION
; ----------------------------------------------

	ver="MCKwatch - build050328"
	title ver

; ----------------------------------------------
; VALIABLE INITIALIZE
; ----------------------------------------------

	sdim mml,32700
	sdim fname,128
	sdim ddname,128
	sdim fpath,512
	sdim ddpath,512
	sdim tmp,4096
	dim wsiz,8
	dim tms,24
	dim bktms,24

; ----------------------------------------------
; INIFILE LOAD
; ----------------------------------------------
	;wsiz=,c,XW,YW,,ϊmck,t
	wsiz=600,300,0,0,0,2,0 : cmpmode=2
	exist exedir+"\\mckw_cfg.ini"
	if strsize!=-1 {
		bload exedir+"\\mckw_cfg.ini",wsiz
		lang=wsiz.4 : cmpmode=wsiz.5 : plyr=wsiz.6
	}

; ----------------------------------------------
; WINDOW INITIALIZE (resize mode)
; ----------------------------------------------
	screen 0,dispx,dispy,2,wsiz.2,wsiz.3 : cls 1
	objmode 2,1 : font "Arial",12
	mref bmscr, 67
	prm = bmscr.13, -16
	dllproc "GetWindowLongA", prm, 2 ,D_USER
	prm.2 = dllret | 0x50000
	dllproc "SetWindowLongA", prm, 3, D_USER
	width wsiz.0,wsiz.1,wsiz.2,wsiz.3

; ----------------------------------------------
; WINDOW OBJECT SET
; ----------------------------------------------

	pos 000,030 : mesbox mml,winx,winy-30,5,32700	;#0 MML\̈
	objsize 60,20
	pos 005,005 : button "off",*btn			;#1 Ď[h
	pos 080,005 : button "load",*btn		;#2 t@C[h
	pos 140,005 : button "save",*btn		;#3 t@CZ[u
	pos 200,005 : button "errlog",*btn		;#4 G[Oďo
	objsize 80,20
	pos 300,005 : button "[ eng ]",*btn		;#5 
	pos 390,005 : combox cmpmode,100,"mck\npmck\nppmck\nHUSIC\nKSR"	;#6 RpC
	pos 480,005 : combox plyr,100,"no play\nd-click\nVirtuaNSF\nG-NSF\nNSFPLAY"		;#7 t
	gsel 0,1 : onexit *p_end
	wait 1 : a=5 : b=1 : gosub *btn2 : b=0
	dd_accept tmp,c,0

; ----------------------------------------------
; MAIN ROUTINE
; ----------------------------------------------
*main
	; EBhETCYωmF
	if (winx!=bkx)|(winy!=bky) {
		wsiz=winx,winy-30,0,30 : bkx=winx : bky=winy
		resizeobj 0,wsiz : objsel 0
	}

	; ^CX^vXVmF
	if (wat=1) {
		fxtget tms,fpath : b=0 : repeat 8 : a=cnt+8
		if (tms.a!=bktms.a) : b=1
		loop
		if b=1 : goto *compil
		b=0
	}

	; hbvt@CmF
	if c>0 : goto *ddrop

	; V[gJbgL[mF
	getkey a,17 : ginfo 1
	getkey b,83 : if (prmx=0)&(a=1)&(b=1) : gosub *F_SAV		; CTRL+S
	getkey b,76 : if (prmx=0)&(a=1)&(b=1) : a=4 : b=0 : goto *btn2	; CTRL+L

	; g@\ďo
	getkey a,112 : if (prmx=0)&(a=1) {
		exist exedir+"\\mckwuty.exe"
		if strsize!=-1 : exec exedir+"\\mckwuty.exe"
		b=112
		}
	getkey a,116 : if (prmx=0)&(a=1) {
		exist exedir+"\\mumem.exe"
		if strsize!=-1 : exec exedir+"\\mumem.exe"
		b=116
		}
	repeat : ginfo 1 : getkey a,b
	if (prmx=0)&(a=0) : break
	wait 1 : loop : b=0

	wait 3 : goto *main

; ----------------------------------------------
; PROGRAM END
; ----------------------------------------------
*p_end
	ginfo 2 : wsiz=winx+2,winy+2,prmx,prmy,lang,cmpmode,plyr
	bsave exedir+"\\mckw_cfg.ini",wsiz
	end

; ----------------------------------------------
; BUTTON TRIGGER
; ----------------------------------------------
*btn
	a=stat : b=0
*btn2
	if a=1 {
		if (b=0) {
			wat++ : if wat>1 : wat=0
		} else { a=5 }
		if wat=0 : objprm 1,"off"
		if wat=1 : objprm 1,"watch"
		if (wat=1)&(fname="") : wat=0 : objprm 1,"off"
		if wat=1 : fxtget tms,fpath
		}
	if a=2 : gosub *F_LD1
	if a=3 : gosub *F_SAV
	if a=4 {
		exist exedir+"\\mck\\errlog.txt"
		if strsize!=-1 : exec exedir+"\\mck\\errlog.txt",16
		repeat
		getkey b,76 : if b=0 : break
		wait 1 : loop
		}
	if a=5 {
		if (b=0) {
			lang++ : if lang>1 : lang=0
			} else { a=6 }
		if lang=0 : objprm 5,"eng" : font "Arial"
		if lang=1 : objprm 5,"jpn" : font "lr SVbN"
		clrobj 0,0
		pos 000,030 : mesbox mml,winx,winy-30,5,32700
		}
	if a=6 : objprm 6,cmpmode : if b!=0 : a=7
	if a=7 : objprm 7,plyr
	if b=1 : return
	objsel 0 : goto *main
; ----------------------------------------------
; DRAG & DROP CHECKSUM
; ----------------------------------------------
*ddrop
	if (c!=1) {
		dialog "hbvł̂͂Pt@Ĉ݂ł.",1,"ERROR" : c=0
		goto *main
	}

	notesel tmp : noteget ddpath,0 : c=0
	getpath tmp,ddpath,2 : charupper tmp
	if (tmp!=".MML")&(tmp!=".MCK")&(tmp!=".MUS") {
		dialog "Ήt@Cł.",1,"ERROR" : goto *main
	}

	fpath=ddpath : getpath fname,ddpath,9
	gosub *F_LD2
	goto *main

; ----------------------------------------------
; FILE LOAD
; ----------------------------------------------
*F_LD1
	wat=0 : objprm 0,"off"
	dialog "mml;*.mck;*.mus",16,"MML source file"
	if stat=0 : return
	fpath=refstr : getpath fname,refstr,9

*F_LD2
	strlen a,mml if a>0 {
		repeat a : poke mml,cnt,$00 : loop
		}
	bload fpath,mml
	objprm 0,mml : wat=1
	title ver+" - "+fname
	fxtget tms,fpath : fxtget bktms,fpath
	a=1 : b=1 : gosub *btn2 : b=0
	return

; ----------------------------------------------
; FILE SAVE
; ----------------------------------------------
*F_SAV
	if fpath="" {
		dialog "mml",17,"Save mml source"
		if stat=0 : return

		notesel mml : notesave refstr
		fpath=refstr : getpath fname,fpath,9
		fxtget bktms : fxtget tms
	} else {
		notesel mml : notesave fpath
	}
	repeat
	getkey b,83 : if b=0 : break
	wait 1 : loop
	return

; ----------------------------------------------
; COMPILE ENGINE
; ----------------------------------------------
*compil
	if fpath="" {
		dialog "Found invalid compile jump.\nsȓm܂.",1,"ERROR" : end
	}

	dd_reject 0,0
	fxtget tms,fpath : fxtget bktms,fpath
	getpath ddpath,fpath,32

; delete temp file
	exist exedir+"\\makensf.bat" :      if strsize!=-1 : delete exedir+"\\makensf.bat"
	exist exedir+"\\mck\\errlog.txt" :  if strsize!=-1 : delete exedir+"\\mck\\errlog.txt"
	exist exedir+"\\mck\\errlog2.txt" : if strsize!=-1 : delete exedir+"\\mck\\errlog2.txt"
	if cmpmode<3 : exist ddpath+fname+".nsf" : if strsize!=-1 : delete ddpath+fname+".nsf"
	if cmpmode=3 : exist ddpath+fname+".hes" : if strsize!=-1 : delete ddpath+fname+".hes"
	if cmpmode=4 : exist ddpath+fname+".kss" : if strsize!=-1 : delete ddpath+fname+".kss"
	wait 5

; batchfile generate (NSF)
; -------------------------
	tmp=""
	tmp+="@echo off\ncd "+ddpath+"\n"

	if cmpmode=0 : tmp+="SET NES_INCLUDE="+exedir+"\\mck\\nes_include\\mck\n"
	if cmpmode=1 : tmp+="SET NES_INCLUDE="+exedir+"\\mck\\nes_include\\pmck\n"
	if cmpmode=2 : tmp+="SET NES_INCLUDE="+exedir+"\\mck\\nes_include\n"
	if cmpmode=3 : tmp+="copy "+fpath+" "+exedir+"\\mck\\hes_include\\songdata.mml\ngoto compile\n"
	if cmpmode=4 : tmp+="copy "+fpath+" "+exedir+"\\mck\\ksr_include\\songdata.mml\ngoto compile\n"

	tmp+="if not exist effect.h goto compile\n"
	tmp+="del effect.h\n"
	tmp+=":compile\n"

	if cmpmode=0 : tmp+=exedir+"\\mck\\bin\\mckc -i "+ddpath+fname+".mml >> "+exedir+"\\mck\\errlog.txt\n"
	if cmpmode=1 : tmp+=exedir+"\\mck\\bin\\pmckc -i "+ddpath+fname+".mml >> "+exedir+"\\mck\\errlog.txt\n"
	if cmpmode=2 : tmp+=exedir+"\\mck\\bin\\ppmckc -i "+ddpath+fname+".mml >> "+exedir+"\\mck\\errlog.txt\n"
	if cmpmode=3 {
		tmp+="cd "+exedir+"\\mck\\hes_include\n"
		tmp+="mckc songdata.mml >> "+exedir+"\\mck\\errlog.txt\n"
		}
	if cmpmode=4 {
		tmp+="cd "+exedir+"\\mck\\ksr_include\n"
		tmp+="mckc -i songdata.mml >> "+exedir+"\\mck\\errlog.txt\n"
		}

	if cmpmode<3 {
		tmp+="if not exist effect.h goto err1\n"
		tmp+="if not exist ppmck.nes goto assemble\n"
		if cmpmode<2 : tmp+="del make_nsf.nes\n"
		if cmpmode=2 : tmp+="del ppmck.nes\n"
		}
	if cmpmode=3 {
		tmp+="if not exist hus_hes.s goto err1\n"
		}
	if cmpmode=4 {
		tmp+="if not exist effect.h goto err1\n"
		}

	tmp+=":assemble\n"

	if cmpmode<2 {
		tmp+=exedir+"\\mck\\bin\\nesasm -s -raw make_nsf.txt >> "+exedir+"\\mck\\errlog.txt\n"
		tmp+="if not exist make_nsf.nes goto err2\n"
		tmp+="move make_nsf.nes "+ddpath+fname+".nsf\n"
		}
	if cmpmode=2 {
		tmp+=exedir+"\\mck\\bin\\nesasm -s -raw ppmck.asm >> "+exedir+"\\mck\\errlog.txt\n"
		tmp+="if not exist ppmck.nes goto err2\n"
		tmp+="move ppmck.nes "+ddpath+fname+".nsf\n"
		}
	if cmpmode=3 {
		tmp+=exedir+"\\mck\\hes_include\\pceas -raw hus_hes.s >> "+exedir+"\\mck\\errlog.txt\n"
		tmp+="if not exist hus_hes.pce goto err2\n"
		tmp+="move hus_hes.pce "+ddpath+fname+".hes\n"
		}
	if cmpmode=4 {
		tmp+=exedir+"\\mck\\ksr_include\\pasmo ksr_rom.asm ksr_drv.rom >> "+exedir+"\\mck\\errlog.txt\n"
		tmp+=exedir+"\\mck\\ksr_include\\pasmo kss_hdr.asm kss_hed.bin >> "+exedir+"\\mck\\errlog.txt\n"
		tmp+="copy /b kss_hed.bin+ksr_drv.rom "+ddpath+fname+".kss >> "+exedir+"\\mck\\errlog.txt\n"
		}

	tmp+="goto finally\n"
	tmp+=":err1\necho mckc compile error. > "+exedir+"\\mck\\errlog2.txt\n"
	tmp+="goto finally\n"

	if cmpmode<3 : tmp+=":err2\necho nesasm assemble error. > "+exedir+"\\mck\\errlog2.txt\n"
	if cmpmode=3 : tmp+=":err2\necho pceas assemble error. > "+exedir+"\\mck\\errlog2.txt\n"
	if cmpmode=4 : tmp+=":err2\necho pasmo assemble error. > "+exedir+"\\mck\\errlog2.txt\n"

	tmp+="goto finally\n"
	tmp+=":finally"

	strlen a,tmp
	notesel tmp : notesave exedir+"\\makensf.bat"

; batchfile create checksum
; --------------------------
	a=0 : b=0
	repeat
	exist exedir+"\\makensf.bat"
	if strsize!=-1 : break
	a++ : if a>100 : b=1 : break
	wait 3 : loop
	if b=1 {
		dialog "ob`t@C쐬ł܂.",1,"ERROR"
		a=0 : b=0 : dd_reject 0,1 : goto *cmpend
	}
	a=0 : b=0
	exec exedir+"\\makensf.bat",1

	repeat
	if cmpmode<3 {
		exist ddpath+fname+".nsf"
		if strsize!=-1 : break
		}
	if cmpmode=3 {
		exist ddpath+fname+".hes"
		if strsize!=-1 : break
		}
	if cmpmode=4 {
		exist ddpath+fname+".kss"
		if strsize!=-1 : break
		}
	exist exedir+"\\mck\\errlog2.txt"
	if strsize!=-1 : b=1 : break
	a++ : if a>100 : b=1 : break
	wait 3 : loop
	if b=1 {
		dialog "RpC̓AZuɎs܂.",1,"ERROR"
		a=0 : b=0 : dd_reject 0,1 : goto *cmpend
	}

*cmpend
	exist ddpath+fname+".h" :      if strsize!=-1 : delete ddpath+fname+".h"
	exist exedir+"\\makensf.bat" : if strsize!=-1 : delete exedir+"\\makensf.bat"
	exist exedir+"\\define.inc" :  if strsize!=-1 : delete exedir+"\\define.inc"
	exist exedir+"\\mck\\ksr_include\\ksr_drv.rom" : if strsize!=-1 : delete exedir+"\\mck\\ksr_include\\ksr_drv.rom"
	exist exedir+"\\mck\\ksr_include\\kss_hed.bin" : if strsize!=-1 : delete exedir+"\\mck\\ksr_include\\kss_hed.bin"
	dd_reject 0,1 : a=0 : b=0

; nsf-file playable
	if cmpmode=3 : goto *heschk
	if cmpmode=4 : goto *ksrchk

	exist ddpath+fname+".nsf"
	if strsize=-1 : goto *main

	if plyr=0 : goto *main
	if plyr=1 : exec ddpath+fname+".nsf",16
	if plyr=2 {
		exist exedir+"\\virtuaNSF.exe"
		if strsize!=-1 : exec exedir+"\\virtuaNSF.exe "+ddpath+fname+".nsf"
		}
	if plyr=3 {
		exist exedir+"\\gnsf.exe"
		if strsize!=-1 :  exec exedir+"\\gnsf.exe "+ddpath+fname+".nsf"
		}
	if plyr=4 {
		exist exedir+"\\nsfplay_nez.exe"
		if strsize!=-1 : exec exedir+"\\nsfplay_nez.exe "+ddpath+fname+".nsf"
		exist exedir+"\\nsfplay_hack.exe"
		if strsize!=-1 : exec exedir+"\\nsfplay_hack.exe "+ddpath+fname+".nsf"
	}
	goto *main

*heschk
	exist ddpath+fname+".hes"
	if strsize=-1 : goto *main
	if plyr=1 : exec ddpath+fname+".hes",16
	if plyr=4 {
		exist exedir+"\\nsfplay_nez.exe"
		if strsize!=-1 : exec exedir+"\\nsfplay_nez.exe "+ddpath+fname+".hes"
		exist exedir+"\\nsfplay_hack.exe"
		if strsize!=-1 : exec exedir+"\\nsfplay_hack.exe "+ddpath+fname+".hes"
	}
	goto *main

*ksrchk
	exist ddpath+fname+".kss"
	if strsize=-1 : goto *main
	if plyr=1 : exec ddpath+fname+".kss",16
	goto *main
